Scrollspy

Bootstrap scrollspy

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

Scrollspy allows you to automatically update Bootstrap navigation or list group components based on the scroll position to indicate which link is currently active in the viewport.


How it works

Scrollspy has a few requirements to function properly:

  • If you’re building our JavaScript from source, it requires util.js.
  • It must be used on a nav component or a list group.
  • Scrollspy requires position: relative on the element you’re spying on, usually the <body>.
  • When spying on elements other than the <body>, be sure to have a height set and overflow-y: scroll applied.
  • Anchors ( <a>) are required and must point to an element with that id.

When successfully implemented, your nav or list group will update accordingly, moving the .active class from one item to the next based on their associated targets.



Example with nested nav

Scrollspy also works with nested .navs. If a nested .nav is .active, its parents will also be .active. Scroll the area next to the navbar and watch the active class change.

Item 1

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 1-1

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 2-2

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 2

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 3

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 3-1

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Item 3-2

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

        
            

        <div class="row">
          <div class="col-sm-4 col-lg-3">
            <nav id="navbar-example3" class="navbar navbar-light bg-light flex-column mt-4">
              <a class="navbar-brand" href="#">Navbar</a>
              <nav class="nav nav-pills flex-column">
                <a class="nav-link active" href="#item-1">Item 1</a>
                <nav class="nav nav-pills flex-column">
                  <a class="nav-link ml-3 my-1" href="#item-1-1">Item 1-1</a>
                  <a class="nav-link ml-3 my-1" href="#item-1-2">Item 1-2</a>
                </nav>
                <a class="nav-link" href="#item-2">Item2</a>
                <a class="nav-link" href="#item-3">Item3</a>
                <nav class="nav nav-pills flex-column">
                  <a class="nav-link ml-3 my-1" href="#item-3-1">Item 3-1</a>
                  <a class="nav-link ml-3 my-1" href="#item-3-2">Item 3-2</a>
                </nav>
              </nav>
            </nav>
          </div>

          <div class="col-sm-8 col-lg-9">
            <div data-spy="scroll" class="scrollspy-example z-depth-1 mt-4" data-target="#navbar-example3"
              data-offset="0">
              <h4 id="item-1">Item 1</h4>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h5 id="item-1-1">Item 1-1</h5>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h5 id="item-1-2">Item 2-2</h5>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h4 id="item-2">Item 2</h4>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h4 id="item-3">Item 3</h4>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h5 id="item-3-1">Item 3-1</h5>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
              <h5 id="item-3-2">Item 3-2</h5>
              <p>Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out
                qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim
                qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic.
                Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.</p>
            </div>
          </div>
        </div>

      
        
    
        
            

        .scrollspy-example {
          height: 360px;
        }

      
        
    

Example with list-group

Scrollspy also works with .list-groups. Scroll the area next to the list group and watch the active class change.

Item 1

Ex consequat commodo adipisicing exercitation aute excepteur occaecat ullamco duis aliqua id magna ullamco eu. Do aute ipsum ipsum ullamco cillum consectetur ut et aute consectetur labore. Fugiat laborum incididunt tempor eu consequat enim dolore proident. Qui laborum do non excepteur nulla magna eiusmod consectetur in. Aliqua et aliqua officia quis et incididunt voluptate non anim reprehenderit adipisicing dolore ut consequat deserunt mollit dolore. Aliquip nulla enim veniam non fugiat id cupidatat nulla elit cupidatat commodo velit ut eiusmod cupidatat elit dolore.

Item 2

Quis magna Lorem anim amet ipsum do mollit sit cillum voluptate ex nulla tempor. Laborum consequat non elit enim exercitation cillum aliqua consequat id aliqua. Esse ex consectetur mollit voluptate est in duis laboris ad sit ipsum anim Lorem. Incididunt veniam velit elit elit veniam Lorem aliqua quis ullamco deserunt sit enim elit aliqua esse irure. Laborum nisi sit est tempor laborum mollit labore officia laborum excepteur commodo non commodo dolor excepteur commodo. Ipsum fugiat ex est consectetur ipsum commodo tempor sunt in proident.

Item 3

Quis anim sit do amet fugiat dolor velit sit ea ea do reprehenderit culpa duis. Nostrud aliqua ipsum fugiat minim proident occaecat excepteur aliquip culpa aute tempor reprehenderit. Deserunt tempor mollit elit ex pariatur dolore velit fugiat mollit culpa irure ullamco est ex ullamco excepteur.

Item 4

Quis anim sit do amet fugiat dolor velit sit ea ea do reprehenderit culpa duis. Nostrud aliqua ipsum fugiat minim proident occaecat excepteur aliquip culpa aute tempor reprehenderit. Deserunt tempor mollit elit ex pariatur dolore velit fugiat mollit culpa irure ullamco est ex ullamco excepteur.

        
            

        <div class="row">
          <div class="col-4">
            <div id="list-example" class="list-group">
              <a class="list-group-item list-group-item-action active" href="#list-item-1">Item 1</a>
              <a class="list-group-item list-group-item-action" href="#list-item-2">Item2</a>
              <a class="list-group-item list-group-item-action" href="#list-item-3">Item 3</a>
              <a class="list-group-item list-group-item-action" href="#list-item-4">Item 4</a>
            </div>
          </div>
          <div class="col-8">
            <div data-spy="scroll" data-target="#list-example" data-offset="0" class="scrollspy-example z-depth-1">
              <h4 id="list-item-1">Item 1</h4>
              <p>Ex consequat commodo adipisicing exercitation aute excepteur occaecat ullamco duis aliqua id magna
                ullamco eu. Do aute ipsum ipsum ullamco cillum consectetur ut et aute consectetur labore. Fugiat
                laborum incididunt tempor eu consequat enim dolore proident. Qui laborum do non excepteur nulla magna
                eiusmod consectetur in. Aliqua et aliqua officia quis et incididunt voluptate non anim reprehenderit
                adipisicing dolore ut consequat deserunt mollit dolore. Aliquip nulla enim veniam non fugiat id
                cupidatat nulla elit cupidatat commodo velit ut eiusmod cupidatat elit dolore.</p>
              <h4 id="list-item-2">Item 2</h4>
              <p>Quis magna Lorem anim amet ipsum do mollit sit cillum voluptate ex nulla tempor. Laborum consequat non
                elit enim exercitation cillum aliqua consequat id aliqua. Esse ex consectetur mollit voluptate est in
                duis laboris ad sit ipsum anim Lorem. Incididunt veniam velit elit elit veniam Lorem aliqua quis
                ullamco deserunt sit enim elit aliqua esse irure. Laborum nisi sit est tempor laborum mollit labore
                officia laborum excepteur commodo non commodo dolor excepteur commodo. Ipsum fugiat ex est consectetur
                ipsum commodo tempor sunt in proident.</p>
              <h4 id="list-item-3">Item 3</h4>
              <p>Quis anim sit do amet fugiat dolor velit sit ea ea do reprehenderit culpa duis. Nostrud aliqua ipsum
                fugiat minim proident occaecat excepteur aliquip culpa aute tempor reprehenderit. Deserunt tempor
                mollit elit ex pariatur dolore velit fugiat mollit culpa irure ullamco est ex ullamco excepteur.</p>
              <h4 id="list-item-4">Item 4</h4>
              <p>Quis anim sit do amet fugiat dolor velit sit ea ea do reprehenderit culpa duis. Nostrud aliqua ipsum
                fugiat minim proident occaecat excepteur aliquip culpa aute tempor reprehenderit. Deserunt tempor
                mollit elit ex pariatur dolore velit fugiat mollit culpa irure ullamco est ex ullamco excepteur.</p>
            </div>
          </div>
        </div>

      
        
    
        
            

        .scrollspy-example {
          height: 360px;
        }
      
        
    

MDB Scrollspy MDB Pro component

Section 1

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 1A

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 1B

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 1C

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!

Section 2

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 2A

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 2B

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!


Subsection 2C

Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores asperiores earum quis!

        
            

      <!--Grid row-->
      <div class="row">

        <!--Grid column-->

        <div class="col-md-8">

          <!--Spied element-->
          <div class="scrollspy-example
   z-depth-1 text-center p-0" data-spy="scroll" data-target="#mdb-scrollspy-ex" data-offset="0">


            <section id="section1" class="blue lighten-4">

              <h3>

                <strong>Section 1</strong>
              </h3>
              <p>Lorem ipsum dolor sit amet consectetur adipisicing
                elit. Dolorem ipsa at provident qui doloremque
                libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi
                officiis quasi dolores
                asperiores earum quis!</p>
              <hr>
              <section id="subsection1A" class=" m-4 red lighten-4">
                <h4>
                  Subsection 1A
                </h4>
                <p>Lorem
                  ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque
                  libero quo non pariatur
                  quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores
                  asperiores earum quis!</p>
              </section>

              <hr>
              <section id="subsection1B" class=" m-4 green lighten-4">
                <h4>

                  Subsection 1B
                </h4>
                <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa
                  at provident qui doloremque
                  libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi
                  dolores
                  asperiores earum quis!</p>
              </section>
              <hr>
              <section id="subsection1C" class=" m-4 indigo lighten-4">
                <h4>
                  Subsection 1C

                </h4>
                <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque

                  libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores
                  asperiores earum quis!</p>

              </section>
            </section>
            <section id="section2" class="blue lighten-4">

              <h3>
                <strong>Section 2</strong>
              </h3>
              <p>Lorem ipsum dolor sit
                amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque
                libero quo non pariatur quaerat iure,
                nostrum, possimus vitae sequi officiis quasi dolores
                asperiores earum quis!</p>
              <hr>

              <section id="subsection2A" class=" m-4 red lighten-4">
                <h4>
                  Subsection
                  2A
                </h4>
                <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident
                  qui doloremque
                  libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores

                  asperiores earum quis!</p>
              </section>
              <hr>
              <section id="subsection2B" class=" m-4 green lighten-4">
                <h4>
                  Subsection 2B
                </h4>
                <p>Lorem
                  ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa at provident qui doloremque
                  libero quo non pariatur
                  quaerat iure, nostrum, possimus vitae sequi officiis quasi dolores
                  asperiores earum quis!</p>
              </section>

              <hr>
              <section id="subsection2C" class=" m-4 indigo lighten-4">
                <h4>

                  Subsection 2C
                </h4>
                <p>Lorem ipsum dolor sit amet consectetur adipisicing elit. Dolorem ipsa
                  at provident qui doloremque
                  libero quo non pariatur quaerat iure, nostrum, possimus vitae sequi officiis quasi
                  dolores
                  asperiores earum quis!</p>
              </section>
            </section>


          </div>
          <!--/.Spied element-->

        </div>
        <!--Grid column-->


        <!--Grid column-->
        <div class="col-md-3 mb-4">

          <!--Scrollspy-->

          <div id="mdb-scrollspy-ex">

            <!-- Links -->
            <ul class="nav nav-pills
   default-pills smooth-scroll">
              <li class="nav-item">
                <a class="nav-link" href="#section1">Section 1</a>
                <ul class="nav ml-3">
                  <li class="nav-item">

                    <a class="nav-link" href="#subsection1A">Subsection 1A</a>
                  </li>

                  <li class="nav-item">
                    <a class="nav-link" href="#subsection1B">Subsection
                      1B</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#subsection1C">Subsection 1C</a>
                  </li>
                </ul>
              </li>

              <li class="nav-item">
                <a class="nav-link" href="#section1">Section 2</a>

                <ul class="nav ml-3">
                  <li class="nav-item">
                    <a class="nav-link" href="#subsection2A">Subsection 2A</a>
                  </li>
                  <li class="nav-item">

                    <a class="nav-link" href="#subsection2B">Subsection 2B</a>
                  </li>

                  <li class="nav-item">
                    <a class="nav-link" href="#subsection2C">Subsection
                      2C</a>
                  </li>
                </ul>
              </li>
            </ul>
            <!-- Links
   -->

          </div>
          <!--Scrollspy-->

        </div>
        <!--Grid
   column-->

      </div>
      <!--Grid row-->

    
        
    
        
            

      #mdb-scrollspy-ex .nav-item {
        width: 100%;
      }

      #mdb-scrollspy-ex a {
        font-size: .8rem;
        font-weight: 400;
        line-height: 1.1rem;
        padding: 0 5px;
        margin-top: 3px;
        margin-bottom: 3px;
        color: black;
      }

      #mdb-scrollspy-ex li .active {
        font-weight: 600;
      }

      .mdb-scrollspy-ex-example {
        height: 200px;
      }

    
        
    

Dotted Scrollspy MDB Pro component

Making the navigation more informative and intuitive is still a challenge to most developers.

Thanks to dotted ScrollSpy, this issue is simply resolved with the use of sticking elements that indicate on which part of the page your users are, and how much longer they can expect the website to be loading.

Another invaluable option that comes with dotted ScrollSpy is the ability to swiftly switch between desired parts of your webpage with just one click.

Live Example
        
            

        <section id="one"></section>
        <section id="two"></section>
        <section id="three"></section>
        <section id="four"></section>
        <section id="five"></section>
        <section id="six"></section>

        <!-- Scrollspy -->
        <div class="dotted-scrollspy">
          <ul class="nav smooth-scroll clearfix d-none d-sm-flex flex-column">
            <li class="nav-item"><a class="nav-link" href="#one"><span></span></a></li>
            <li class="nav-item"><a class="nav-link" href="#two"><span></span></a></li>
            <li class="nav-item"><a class="nav-link" href="#three"><span></span></a></li>
            <li class="nav-item"><a class="nav-link" href="#four"><span></span></a></li>
            <li class="nav-item"><a class="nav-link" href="#five"><span></span></a></li>
            <li class="nav-item"><a class="nav-link" href="#six"><span></span></a></li>
          </ul>
        </div>

      
        
    
        
            

        $('body').scrollspy({
          target: '.dotted-scrollspy'
        });
      
        
    

Usage


Via data attributes

To easily add scrollspy behavior to your topbar navigation, add data-spy="scroll" to the element you want to spy on (most typically this would be the <body>). Then add the data-target attribute with the ID or class of the parent element of any Bootstrap .nav component.

        
            

        <body data-spy="scroll" data-target="#navbar-example">
          ...
          <div id="navbar-example">
            <ul class="nav nav-tabs" role="tablist">
              ...
            </ul>
          </div>
          ...
        </body>
      
        
    
        
            
        body {
          position: relative;
        }
      
        
    

Via JavaScript

        
            
        $('body').scrollspy({ target: '#navbar-example' })
      
        
    

Resolvable ID targets are required

Navbar links must have resolvable id targets. For example, a <a href="#home">home</a> must correspond to something in the DOM like <div id="home"></div>.

Non- :visible target elements are ignored

Target elements that are not :visible according to jQuery will be ignored and their corresponding nav items will never be highlighted.

Methods

.scrollspy('refresh')

When using scrollspy in conjunction with adding or removing elements from the DOM, you’ll need to call the refresh method like so:

        
            
        $('[data-spy="scroll"]').each(function () {
          var $spy = $(this).scrollspy('refresh')
        })
      
        
    
.scrollspy('dispose')

Destroys an element’s scrollspy.

Options

Options can be passed via data attributes or JavaScript. For data attributes, append the option name to data-, as in data-offset="".

Name Type Default Description
offset number 10 Pixels to offset from the top when calculating the position of scroll.
method string auto Finds which section the spied element is in. auto will choose the best method to get the scroll coordinates. offset will use the jQuery offset method to get the scroll coordinates. position will use the jQuery position method to get the scroll coordinates.
target string Specifies the element to apply the Scrollspy plugin to.

Events

Event Type Description
activate.bs.scrollspy This event fires whenever a new item becomes activated by the scrollspy.
        
            
    $('#myScrollspy').on('activate.bs.scrollspy', function () {
     // do something…
    })

React Bootstrap Scrollspy MDB Pro component

React Scrollspy - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap scrollspy autmatically updates tabs, navigation or list group components based on scroll position to indicate which link is currently active in the viewport.



Example with list group

Scrollspy also works with ListGroup. Scroll the area next to the list group and watch the active class change.

section1

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

section2

Veniam marfa mustache skateboard, adipisicing fugiat velit pitchfork beard. Freegan beard aliqua cupidatat mcsweeney's vero. Cupidatat four loko nisi, ea helvetica nulla carles. Tattooed cosby sweater food truck, mcsweeney's quis non freegan vinyl. Lo-fi wes anderson +1 sartorial. Carles non aesthetic exercitation quis gentrify. Brooklyn adipisicing craft beer vice keytar deserunt.

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

section3

Occaecat commodo aliqua delectus. Fap craft beer deserunt skateboard ea. Lomo bicycle rights adipisicing banh mi, velit ea sunt next level locavore single-origin coffee in magna veniam. High life id vinyl, echo park consequat quis aliquip banh mi pitchfork. Vero VHS est adipisicing. Consectetur nisi DIY minim messenger bag. Cred ex in, sustainable delectus consectetur fanny pack iphone.

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

section4

Veniam marfa mustache skateboard, adipisicing fugiat velit pitchfork beard. Freegan beard aliqua cupidatat mcsweeney's vero. Cupidatat four loko nisi, ea helvetica nulla carles. Tattooed cosby sweater food truck, mcsweeney's quis non freegan vinyl. Lo-fi wes anderson +1 sartorial. Carles non aesthetic exercitation quis gentrify. Brooklyn adipisicing craft beer vice keytar deserunt.

Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle rights whatever. Anim keffiyeh carles cardigan. Velit seitan mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean shorts, williamsburg hoodie minim qui you probably haven't heard of them et cardigan trust fund culpa biodiesel wes anderson aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh artisan ullamco consequat.

        
            
            import React from "react";
            import { MDBScrollspyBox, MDBScrollspyText, MDBListGroup, MDBListGroupItem, MDBRow, MDBCol } from "mdbreact";
  
            class ScrollSpyPage extends React.Component {
              constructor(props) {
                super(props);
                this.state = {
                  active: 0,
                  sections: []
                };
  
                this.scrollSpyText = React.createRef();
              }
  
            componentDidMount() {
              let sections = this.scrollSpyText.current.getElementsByTagName("h4");
              this.setState({ sections });
            }
  
            handleScroll = (e) => {
              const scrollTop = e.target.scrollTop;
              const sections = this.state.sections;
              const lastIndex = sections.length - 1;
  
              for (let i = 0; i < lastIndex; i++) {
                if ((scrollTop> sections[i].offsetTop - 20) && (scrollTop < sections[i +1].offsetTop - 20)) {
                  this.setState({ active: i });
                }
              };
  
              if (scrollTop> sections[lastIndex].offsetTop - 20) this.setState({ active: lastIndex });
            }
  
            render() {
              return (
                <MDBScrollspyBox>
                  <MDBRow>
                    <MDBCol md="3">
                      <MDBListGroup>
                        <MDBListGroupItem href="#section1" active={this.state.active===0}>section1</MDBListGroupItem>
                        <MDBListGroupItem href="#section2" active={this.state.active===1}>section2</MDBListGroupItem>
                        <MDBListGroupItem href="#section3" active={this.state.active===2}>section3</MDBListGroupItem>
                        <MDBListGroupItem href="#section4" active={this.state.active===3}>section4</MDBListGroupItem>
                      </MDBListGroup>
                    </MDBCol>
                    <MDBCol>
                      <MDBScrollspyText onScroll={this.handleScroll} scrollSpyRef={this.scrollSpyText}>
                        <h4 id="section1">section1</h4>
                        <p>
                          Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr
                          enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle
                          rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                          mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean
                          shorts, williamsburg hoodie minim qui you probably haven't heard
                          of them et cardigan trust fund culpa biodiesel wes anderson
                          aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh
                          artisan ullamco consequat.
                        </p>
                        <p>
                          Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr
                          enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle
                          rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                          mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean
                          shorts, williamsburg hoodie minim qui you probably haven't heard
                          of them et cardigan trust fund culpa biodiesel wes anderson
                          aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh
                          artisan ullamco consequat.
                        </p>
                        <h4 id="section2">section2</h4>
                        <p>
                          Veniam marfa mustache skateboard, adipisicing fugiat velit
                          pitchfork beard. Freegan beard aliqua cupidatat mcsweeney's vero.
                          Cupidatat four loko nisi, ea helvetica nulla carles. Tattooed
                          cosby sweater food truck, mcsweeney's quis non freegan vinyl.
                          Lo-fi wes anderson +1 sartorial. Carles non aesthetic exercitation
                          quis gentrify. Brooklyn adipisicing craft beer vice keytar
                          deserunt.
                        </p>
                        <p>
                          Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr
                          enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle
                          rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                          mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean
                          shorts, williamsburg hoodie minim qui you probably haven't heard
                          of them et cardigan trust fund culpa biodiesel wes anderson
                          aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh
                          artisan ullamco consequat.
                        </p>
                        <h4 id="section3">section3</h4>
                        <p>
                          Occaecat commodo aliqua delectus. Fap craft beer deserunt
                          skateboard ea. Lomo bicycle rights adipisicing banh mi, velit ea
                          sunt next level locavore single-origin coffee in magna veniam.
                          High life id vinyl, echo park consequat quis aliquip banh mi
                          pitchfork. Vero VHS est adipisicing. Consectetur nisi DIY minim
                          messenger bag. Cred ex in, sustainable delectus consectetur fanny
                          pack iphone.
                        </p>
                        <p>
                          Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr
                          enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle
                          rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                          mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean
                          shorts, williamsburg hoodie minim qui you probably haven't heard
                          of them et cardigan trust fund culpa biodiesel wes anderson
                          aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh
                          artisan ullamco consequat.
                        </p>
                        <h4 id="section4">section4</h4>
                        <p>
                          Veniam marfa mustache skateboard, adipisicing fugiat velit
                          pitchfork beard. Freegan beard aliqua cupidatat mcsweeney's vero.
                          Cupidatat four loko nisi, ea helvetica nulla carles. Tattooed
                          cosby sweater food truck, mcsweeney's quis non freegan vinyl.
                          Lo-fi wes anderson +1 sartorial. Carles non aesthetic exercitation
                          quis gentrify. Brooklyn adipisicing craft beer vice keytar
                          deserunt.
                        </p>
                        <p>
                          Ad leggings keytar, brunch id art party dolor labore. Pitchfork yr
                          enim lo-fi before they sold out qui. Tumblr farm-to-table bicycle
                          rights whatever. Anim keffiyeh carles cardigan. Velit seitan
                          mcsweeney's photo booth 3 wolf moon irure. Cosby sweater lomo jean
                          shorts, williamsburg hoodie minim qui you probably haven't heard
                          of them et cardigan trust fund culpa biodiesel wes anderson
                          aesthetic. Nihil tattooed accusamus, cred irony biodiesel keffiyeh
                          artisan ullamco consequat.
                        </p>
                      </MDBScrollspyText>
                    </MDBCol>
                  </MDBRow>
                </MDBScrollspyBox>
                );
              }
            }
  
            export default ScrollSpyPage;
          
        
    

React Scrollspy - API

In this section you will find advanced information about the Scrollspy component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use in working with it.


Import statement

React scrollspy can use other components, like ListGropu or Navbar in addition to present current scroll location, so rememeber about proper imports.

Main Scrollspy components:

        
            
            import { MDBScrollspyBox, MDBScrollspyList, MDBScrollspyListItem, MDBScrollspyText  } from "mdbreact";
          
        
    

Import statement

In order to use Scrollspay you have to define scrollable container, and sections inside of it and determine which section is visible.

Our suggestion is to use React ref to watch it's offsetTop property. Then we compare it with offsetTop of nested sections to determine which is active.

Also rememeber that Scrollspy elements (sections and navigation) have to be wrapped inside MDBScrollspyBox and sections have to be inside MDBScrollspyTex.

Sample code looks like this:

        
            
          import React from "react";
          import ReactDOM from 'react-dom';
          import {
            MDBScrollspyBox,
            MDBScrollspyList,
            MDBScrollspyListItem,
            MDBScrollspyText
          } from "mdbreact";
          import DocsLink from "../DocsLink";

          class ScrollSpyPage extends React.Component {
          constructor(props) {
            super(props);
            this.state = {
              active: 0,
              sections: []
            };

            this.scrollSpyText = React.createRef();
          }

          componentDidMount() {
            let sections = this.scrollSpyText.current.getElementsByTagName("h4");
            this.setState({ sections });
          }

          handleScroll = (e) => {
            const scrollTop = e.target.scrollTop;
            const sections = this.state.sections;
            const lastIndex = sections.length - 1;

            for (let i = 0; i < lastIndex; i++) { if ((scrollTop> sections[i].offsetTop - 20) && (scrollTop < sections[i +
              1].offsetTop - 20)) { this.setState({ active: i }); } }; if (scrollTop> sections[lastIndex].offsetTop - 20)
              this.setState({ active: lastIndex });
          }

          render() {
            return (
              <MDBScrollspyBox>
                <MDBScrollspyList>
                  <MDBScrollspyListItem href="#section1" active={this.state.active===0}>
                    section1
                  </MDBScrollspyListItem>
                  <MDBScrollspyListItem href="#section2" active={this.state.active===1}>
                    section2
                  </MDBScrollspyListItem>
                  <MDBScrollspyListItem href="#section3" active={this.state.active===2}>
                    section3
                  </MDBScrollspyListItem>
                </MDBScrollspyList>
                <MDBScrollspyText onScroll={this.handleScroll} scrollSpyRef={this.scrollSpyText}>
                  <div id="section1">section1</div>
                  <div id="section2">section2</div>
                  <div id="section3">section3</div>
                </MDBScrollspyText>
              </MDBScrollspyBox>
            );
          }
        }

        export default ScrollSpyPage;

        
        
    

API Reference: ScrollspyBox Properties

The table below shows the configuration options of the MDBScrollspyBox component.

Name Type Default Description Example
className String Adds custom class to the Stepper component <MDBScrollspyBox className="myClass" />

API Reference: ScrollspyText Properties

The table below shows the configuration options of the MDBScrollspyText component.

Name Type Default Description Example
className String Adds custom class to the Stepper component <MDBScrollspyText className="myClass" />
scrollSpyRef oneOfType[function, object] The React Ref which points on to the div wrapping all the scrollspy content <MDBScrollspyText scrollSpyRef={this.scrollspyRef} />

API Reference: ScrollspyList Properties

The table below shows the configuration options of the MDBScrollspyList component.

Name Type Default Description Example
className String Adds custom class to the Stepper component <MDBScrollspyList className="myClass" />
color String default Changes the background color of the tab scrollspy panel <MDBScrollspyList color="indigo" />

API Reference: ScrollspyListItem Properties

The table below shows the configuration options of the MDBScrollspyListItem component.

Name Type Default Description Example
active Boolean false Sets active state of the list item <MDBScrollspyListItem active={true} />
className String Adds custom class to the Stepper component <MDBScrollspyListItem className="myClass" />